/*
    Copyright (C) 1995-2001 AROS - The Amiga Research OS
    $Id: reslist.c,v 1.1.1.1 2005/03/15 16:00:58 laire Exp $
 
    Desc:
    Lang: english
*/

#include <exec/devices.h>
#include <exec/io.h>
#include <exec/memory.h>
#include <exec/semaphores.h>
#include <exec/tasks.h>
#include <exec/execbase.h>
#include <dos/dosextens.h>
#include <dos/exall.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <aros/machine.h>

#include "reslist_version.h"

static const char version[] = VERSTAG;

struct res
{
	STRPTR name;
	APTR address;
};


static int fillbuffer(struct res **buffer, IPTR size, struct ExecBase *SysBase);

int main(void)
{
	struct ExecBase		*SysBase;
	struct DosLibrary	*DOSBase;
	IPTR size;
	struct res *buffer,*ress,*ress2;
	LONG error=RETURN_OK;

	SysBase=*((struct ExecBase**) 4);
	if ((DOSBase=(struct DosLibrary *)OpenLibrary("dos.library",37))!=0)
	{
		for(size=2048;;size+=2048)
		{
			buffer=AllocVec(size,MEMF_ANY);
			if(buffer==NULL)
			{
				FPuts(Output(),"Not Enough memory for resource buffer\n");
				CloseLibrary((struct Library *) DOSBase);
				return RETURN_FAIL;
			}
			ress=buffer;
			if(fillbuffer(&ress,size,SysBase))
			{
				FPuts(Output(),"address\t\tname\n"
				      "------------------------------------------------------------\n");
				for(ress2=buffer;ress2<ress;ress2++)
				{
					IPTR args[2];
					args[0] = (IPTR)ress2->address;
					args[1] = (IPTR)ress2->name;

					VPrintf("0x%08.lx\t%s\n", args);
					if(SetSignal(0L,SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C)
					{
						error = RETURN_FAIL;
						SetIoErr(ERROR_BREAK);
						break;
					}
				}
				FreeVec(buffer);
				break;
			}
			FreeVec(buffer);
		}
		if (error != RETURN_OK)
		{
			PrintFault(IoErr(), NULL);
		}
		CloseLibrary((struct Library *)DOSBase);
	}

	return error;
}

static int addres(struct Node *r, struct res **l, STRPTR *e)
{
	STRPTR s1, s2;

	(*l)->address = r;

	s1 = r->ln_Name;

	if(s1!=NULL)
	{
		s2=s1;
		while(*s2++)
			;
		while(s2>s1)
		{
			if(*e<=(STRPTR)l)
				return 0;
			*--(*e)=*--s2;
		}
	}
	if((STRPTR)(*l+2)>*e)
		return 0;

	(*l)->name=*e;
	++*l;

	return 1;
}

static int fillbuffer(struct res **buffer, IPTR size, struct ExecBase *SysBase)
{
	STRPTR end=(STRPTR)*buffer+size;
	struct Node *r;
	int ret=1;
	Forbid();
	for(r=(struct Node *)SysBase->ResourceList.lh_Head;
	        r->ln_Succ!=NULL && ret;
	        r=(struct Node *)r->ln_Succ)
		ret=addres(r,buffer,&end);
	Permit();
	return ret;
}

